<template>
    <!-- <li style="margin:0; list-style-type:none;" v-if="path && parentOpened"> -->
    <li style="margin:0; list-style-type:none;">
      <span class="folder" @click="onClickFolder">{{dir(path)}}</span>
      <ul :class='"nested"+(alreadyOpened?" active":"")'>
        <!-- <tree v-for="sub in contents" :parentOpened="opened" :path="sub" :key="sub" />Let the recursion commence -->
        <div v-if="opened">
          <tree v-for="folder in folders" :path="folder" :key="folder" /><!-- Let the recursion commence -->
          <li v-for="file in files" :key="file"><span class="file" :data-path="file" @click="onClickFile">{{dir(file)}}</span></li>
        </div>
      </ul>
    </li>
</template>

<script>

import { messageBus } from '../main.js'
const fs = require('fs')
const pa = require('path')

export default {
  name:  'tree',
  props: {
    path: {
      type: String,
    },
    alreadyOpened: {
      type:    Boolean,
      default: false,
    },
  },
  components: {
    fs,
    pa,
  },

  data () {
    return {
      opened:  this.alreadyOpened,
      // fileStat: fs.statSync(this.path),
      // isDirectory: this.filestat ? this.fileStat.isDirectory() : false,
      // contents: , // .filter(isDirectory)
      // fileStat: fs.lstatSync(this.path),
      folders: [], // [{path:'C:\\Projekte\\basic-y', opened:false}],
      files:   [],
    }
  },
  computed: {
    // fileStat () {
    //   try { return fs.lstatSync(this.path) } catch (err) {
    //     if (err.code==='ENOENT') {
    //       console.log('File does not exist:', this.path)
    //       return null
    //     }
    //     console.log('Filestat error:', err)
    //     return undefined
    //   }
    // },
    // isDirectory () { return this.fileStat ? (this.fileStat.isDirectory()) : false },
    // iconClass () { return this.fileStat ? this.isDirectory ? 'folder' : 'file' : 'invalid' }, // not used right now
  },

  created () {
    this.loadContents()
    // console.log('Filestat:', this.fileStat)
    // console.log('Is Dir', this.isDirectory)
    // console.log('Contents of', this.path, ':', this.contents) // fs.lstatSync(this.path).isDirectory()
  },
  methods: {
    loadContents () {
      let files = fs.readdirSync(this.path) // .map(name => pa.join(this.path, name))
      this.files = []
      this.folders = []
      files.forEach(name => {
        const path = pa.join(this.path, name)
        const stat = fs.statSync(path)
        if (stat.isDirectory())
          this.folders.push(path)
        else
          this.files.push(path)
      })
      this.folders.sort((a, b) => { return a < b })
      this.files.sort((a, b) => { return a < b })
    },
    // fileClick (event) {
    //   console.log(event)
    // },
    onClickFolder (event) {
      // if (this.isDirectory) {
      // event.target.classList.toggle('folder-down')
      // this.opened = event.target.classList.contains('folder-down')
      event.target.parentElement.querySelector('.nested').classList.toggle('active')
      this.opened = event.target.parentElement.querySelector('.nested').classList.contains('active')
      console.log(event.target.parentElement.querySelector('.nested').classList, this.opened)
      // console.log('Folders:', this.folders)
      // }
    },
    onClickFile (event) {
      // console.log('File click:', event.target.dataset.path) // evtl netter
      console.log('File click:', event.target.innerHTML)
      messageBus.$emit('fileOpen', [event.target.dataset.path])
    },

    dir (path) { // duplicate function exists
      if (!path)
        return ''
      const lastSeparator = Math.max(path.lastIndexOf('/'), path.lastIndexOf('\\'))+1
      // console.log('lastSep', lastSeparator)
      return path.substring(lastSeparator)
    },
  },
}
</script>

<style scoped>
  /* ul { list-style-type: none; } instead in li */
  /* li { margin-left: 24px; list-style-type: none; } */
  /* ul { margin-left: 24px; list-style-type: none; } */
  ul { margin-left: 18px; list-style-type: none; }
  li { white-space: nowrap; /*overflow-x:hidden;*/ }
  .nested { display:none; }
  .active { display:block; }

  /* Folders */
  .folder {
    cursor: pointer;
    user-select: none;
  }
  .folder::before {
    content:      '📁'; /* '\25B6'; */
    color:        black;
    /* display:      inline-block; */
    margin-right: 1px; /* prev 5px */
  }
  .folder-down::before { transform:rotate(90deg); }

  /* Files */
  .file {
    cursor: pointer;
    user-select: none;
  }
  .file::before {
    content:      '📄'; /* 📅, 📆, 📈, 📊, 📋?, 📌, 📍, 📐, 📒, 📖, 📕, 📚, 📝, 📦, 📿, 🔍 */
    color:        black;
    /* display:      inline-block; */
    margin-right: 3px; /* prev 8px */
  }

  .invalid::before {
    content:      '📿'; /* 📅, 📆, 📈, 📊, 📋?, 📌, 📍, 📐, 📒, 📖, 📕, 📚, 📝, 📦, 📿, 🔍 */
    color:        black;
    display:      inline-block;
    margin-right: 3px; /* prev 8px */
  }

</style>